#include <iostream>
#include <vector>
int main()
{
    int n;
    std::cin>>n;
    std::vector<int>a(n);
    std::vector<int>b(n);
    for(int i=0; i<n; i++){
        std::cin>>a[i];
    }
    for(int i=0; i<n; i++){
        std::cin>>b[i];
    }
    int max=0;
    int ksor=0;
    int end=1;
    
    for(int r=0; r<n; r++){
            ksor^=a[r];
            end&=b[r];
            if(end==0){
                ksor=0;
                end=1;
            }
        if(ksor*end>max)
        max=ksor*end;
        
        }
        
    std::cout<<max;
    return 0;
}